"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extractCssChunksWebpackPlugin = _interopRequireDefault(require("extract-css-chunks-webpack-plugin"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = function _default(_ref) {
  var _ref$cssLoaderConfigO = _ref.cssLoaderConfigOptions,
      cssLoaderConfigOptions = _ref$cssLoaderConfigO === void 0 ? {} : _ref$cssLoaderConfigO,
      _ref$sassIncludePaths = _ref.sassIncludePaths,
      sassIncludePaths = _ref$sassIncludePaths === void 0 ? [] : _ref$sassIncludePaths,
      _ref$loaderRegexp = _ref.loaderRegexp,
      loaderRegexp = _ref$loaderRegexp === void 0 ? /\.css$/ : _ref$loaderRegexp;
  return {
    webpack: function webpack(config, _ref2) {
      var stage = _ref2.stage;
      var loaders = [];

      var cssLoaderOptions = _objectSpread({
        importLoaders: 1,
        modules: true,
        camelCase: true,
        localIdentName: stage === "dev" ? "[name]__[local]--[hash:base64:5]" : "[hash:base64:5]",
        sourceMap: true
      }, cssLoaderConfigOptions);

      var cssLoader = {
        loader: "css-loader",
        options: cssLoaderOptions
      };
      var postcssLoader = {
        loader: "postcss-loader",
        options: {
          config: {
            // File must be named in one of these formats:
            // https://github.com/michael-ciniawsky/postcss-load-config#usage
            path: "src/configuration/"
          }
        }
      };

      if (stage === "dev") {
        // Dev
        loaders = [{
          loader: _extractCssChunksWebpackPlugin["default"].loader,
          options: {
            hot: true
          }
        }, cssLoader, postcssLoader];
      } else if (stage === "node") {
        // Node
        // Don't extract css to file during node build process
        loaders = [_objectSpread({}, cssLoader, {
          loader: "css-loader",
          options: _objectSpread({}, cssLoaderOptions, {
            exportOnlyLocals: true
          })
        }), postcssLoader];
      } else {
        // Prod
        loaders = [_extractCssChunksWebpackPlugin["default"].loader, cssLoader, postcssLoader];
      }

      config.module.rules[0].oneOf.unshift({
        test: loaderRegexp,
        use: loaders
      }); // config.plugins.push(new ExtractCssChunks());

      return config;
    }
  };
};

exports["default"] = _default;